var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "path", "./processor", "assert"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var path_1 = __importDefault(require("path"));
    var Processor = __importStar(require("./processor"));
    var assert_1 = __importDefault(require("assert"));
    var sourcepath = path_1.default.join(__dirname, "../src/encrypted/testdocument.pdf");
    var invalidsrcpath = path_1.default.join(__dirname, "../src/encrypted/none.pdf");
    var destpath = path_1.default.join(__dirname, "../src/decrypted/testdocument.pdf");
    var invaliddestpath = path_1.default.join(__dirname, "../src/decrypted/none.pdf");
    var password = "testpassword";
    var username = "testusername";
    var invalidpassword = "blahblah";
    var encryptmethod = "encrypt";
    var decryptmethod = "decrypt";
    var invalidmethod = "invalid";
    var processor = new Processor.EncryptDecryptPDF.PDFProcessor(password, username);
    var invalidprocessor = new Processor.EncryptDecryptPDF.PDFProcessor(invalidpassword, username);
    describe("Testing Processor on various test scenarios", function () {
        it("should throw an error for invalid file path for encryption", function () {
            processor
                .encrypt(invalidsrcpath, destpath)
                .then(function (data) {
                assert_1.default.equal(data.error, true);
            })
                .catch(function (e) { return e; });
        });
        it("should throw an error for invalid file path for decryption", function () {
            processor
                .decrypt(invalidsrcpath, destpath)
                .then(function (data) {
                assert_1.default.equal(data.error, true);
            })
                .catch(function (e) { return e; });
        });
        it("should throw an error for invalid method on an encrypted file", function () {
            invalidprocessor
                .encrypt(destpath, sourcepath)
                .then(function (data) {
                assert_1.default.equal(data.error, true);
            })
                .catch(function (e) { return e; });
        });
        it("should successfully decrypt an encrypted file", function () {
            processor
                .decrypt(sourcepath, destpath)
                .then(function (data) {
                assert_1.default.deepEqual(data.error, false);
            })
                .catch(function (e) { return e; });
        });
        it("should throw error for invalid password on file", function () {
            invalidprocessor
                .decrypt(sourcepath, destpath)
                .then(function (data) {
                assert_1.default.deepEqual(data.error, true);
            })
                .catch(function (e) { return e; });
        });
        it("should throw error for encrypting an already encrypted file", function () {
            processor
                .encrypt(sourcepath, destpath)
                .then(function (data) {
                assert_1.default.deepEqual(data.error, true);
            })
                .catch(function (e) { return e; });
        });
        it("should successfully encrpyt a file", function () {
            processor
                .encrypt(destpath, sourcepath)
                .then(function (data) {
                assert_1.default.deepEqual(data.error, false);
            })
                .catch(function (e) { return e; });
        });
    });
});
